<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>NumberToTextConverter (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="NumberToTextConverter (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/NumberToTextConverter.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/util/NumberComparer.html" title="class in org.apache.poi.ss.util"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/util/PaneInformation.html"
               title="class in org.apache.poi.ss.util"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/util/NumberToTextConverter.html"
               target="_top">Frames</a></li>
        <li><a href="NumberToTextConverter.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.util</div>
    <h2 title="Class NumberToTextConverter" class="title">Class NumberToTextConverter</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.util.NumberToTextConverter</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public final class <span class="typeNameLabel">NumberToTextConverter</span>
extends java.lang.Object</pre>
                <div class="block">Excel converts numbers to text with different rules to those of java, so
                    <code>Double.toString(value)</tt> won't do.
                        <ul>
                            <li>No more than 15 significant figures are output (java does 18).</li>
                            <li>The sign char for the exponent is included even if positive</li>
                            <li>Special values (<tt>NaN</tt> and <tt>Infinity</tt>) get rendered like the ordinary
                                number that the bit pattern represents.
                            </li>
                            <li>Denormalised values (between &plusmn;2<sup>-1074</sup> and &plusmn;2<sup>-1022</sup>
                                are displayed as "0"</sup>
                        </ul>
                        IEEE 64-bit Double Rendering Comparison

                        <table border="1" cellpadding="2" cellspacing="0"
                               summary="IEEE 64-bit Double Rendering Comparison">
                            <tr>
                                <th>Raw bits</th>
                                <th>Java</th>
                                <th>Excel</th>
                            </tr>

                            <tr>
                                <td>0x0000000000000000L</td>
                                <td>0.0</td>
                                <td>0</td>
                            </tr>
                            <tr>
                                <td>0x3FF0000000000000L</td>
                                <td>1.0</td>
                                <td>1</td>
                            </tr>
                            <tr>
                                <td>0x3FF00068DB8BAC71L</td>
                                <td>1.0001</td>
                                <td>1.0001</td>
                            </tr>
                            <tr>
                                <td>0x4087A00000000000L</td>
                                <td>756.0</td>
                                <td>756</td>
                            </tr>
                            <tr>
                                <td>0x401E3D70A3D70A3DL</td>
                                <td>7.56</td>
                                <td>7.56</td>
                            </tr>
                            <tr>
                                <td>0x405EDD3C07FB4C99L</td>
                                <td>123.45678901234568</td>
                                <td>123.456789012346</td>
                            </tr>
                            <tr>
                                <td>0x4132D687E3DF2180L</td>
                                <td>1234567.8901234567</td>
                                <td>1234567.89012346</td>
                            </tr>
                            <tr>
                                <td>0x3EE9E409302678BAL</td>
                                <td>1.2345678901234568E-5</td>
                                <td>1.23456789012346E-05</td>
                            </tr>
                            <tr>
                                <td>0x3F202E85BE180B74L</td>
                                <td>1.2345678901234567E-4</td>
                                <td>0.000123456789012346</td>
                            </tr>
                            <tr>
                                <td>0x3F543A272D9E0E51L</td>
                                <td>0.0012345678901234567</td>
                                <td>0.00123456789012346</td>
                            </tr>
                            <tr>
                                <td>0x3F8948B0F90591E6L</td>
                                <td>0.012345678901234568</td>
                                <td>0.0123456789012346</td>
                            </tr>
                            <tr>
                                <td>0x3EE9E409301B5A02L</td>
                                <td>1.23456789E-5</td>
                                <td>0.0000123456789</td>
                            </tr>
                            <tr>
                                <td>0x3E6E7D05BDABDE50L</td>
                                <td>5.6789012345E-8</td>
                                <td>0.000000056789012345</td>
                            </tr>
                            <tr>
                                <td>0x3E6E7D05BDAD407EL</td>
                                <td>5.67890123456E-8</td>
                                <td>5.67890123456E-08</td>
                            </tr>
                            <tr>
                                <td>0x3E6E7D06029F18BEL</td>
                                <td>5.678902E-8</td>
                                <td>0.00000005678902</td>
                            </tr>
                            <tr>
                                <td>0x2BCB5733CB32AE6EL</td>
                                <td>9.999999999999123E-98</td>
                                <td>9.99999999999912E-98</td>
                            </tr>
                            <tr>
                                <td>0x2B617F7D4ED8C59EL</td>
                                <td>1.0000000000001235E-99</td>
                                <td>1.0000000000001E-99</td>
                            </tr>
                            <tr>
                                <td>0x0036319916D67853L</td>
                                <td>1.2345678901234578E-307</td>
                                <td>1.2345678901235E-307</td>
                            </tr>
                            <tr>
                                <td>0x359DEE7A4AD4B81FL</td>
                                <td>2.0E-50</td>
                                <td>2E-50</td>
                            </tr>
                            <tr>
                                <td>0x41678C29DCD6E9E0L</td>
                                <td>1.2345678901234567E7</td>
                                <td>12345678.9012346</td>
                            </tr>
                            <tr>
                                <td>0x42A674E79C5FE523L</td>
                                <td>1.2345678901234568E13</td>
                                <td>12345678901234.6</td>
                            </tr>
                            <tr>
                                <td>0x42DC12218377DE6BL</td>
                                <td>1.2345678901234567E14</td>
                                <td>123456789012346</td>
                            </tr>
                            <tr>
                                <td>0x43118B54F22AEB03L</td>
                                <td>1.2345678901234568E15</td>
                                <td>1234567890123460</td>
                            </tr>
                            <tr>
                                <td>0x43E56A95319D63E1L</td>
                                <td>1.2345678901234567E19</td>
                                <td>12345678901234600000</td>
                            </tr>
                            <tr>
                                <td>0x441AC53A7E04BCDAL</td>
                                <td>1.2345678901234568E20</td>
                                <td>1.23456789012346E+20</td>
                            </tr>
                            <tr>
                                <td>0xC3E56A95319D63E1L</td>
                                <td>-1.2345678901234567E19</td>
                                <td>-12345678901234600000</td>
                            </tr>
                            <tr>
                                <td>0xC41AC53A7E04BCDAL</td>
                                <td>-1.2345678901234568E20</td>
                                <td>-1.23456789012346E+20</td>
                            </tr>
                            <tr>
                                <td>0x54820FE0BA17F46DL</td>
                                <td>1.2345678901234577E99</td>
                                <td>1.2345678901235E+99</td>
                            </tr>
                            <tr>
                                <td>0x54B693D8E89DF188L</td>
                                <td>1.2345678901234576E100</td>
                                <td>1.2345678901235E+100</td>
                            </tr>
                            <tr>
                                <td>0x4A611B0EC57E649AL</td>
                                <td>2.0E50</td>
                                <td>2E+50</td>
                            </tr>
                            <tr>
                                <td>0x7FEFFFFFFFFFFFFFL</td>
                                <td>1.7976931348623157E308</td>
                                <td>1.7976931348623E+308</td>
                            </tr>
                            <tr>
                                <td>0x0010000000000000L</td>
                                <td>2.2250738585072014E-308</td>
                                <td>2.2250738585072E-308</td>
                            </tr>
                            <tr>
                                <td>0x000FFFFFFFFFFFFFL</td>
                                <td>2.225073858507201E-308</td>
                                <td>0</td>
                            </tr>
                            <tr>
                                <td>0x0000000000000001L</td>
                                <td>4.9E-324</td>
                                <td>0</td>
                            </tr>
                            <tr>
                                <td>0x7FF0000000000000L</td>
                                <td>Infinity</td>
                                <td>1.7976931348623E+308</td>
                            </tr>
                            <tr>
                                <td>0xFFF0000000000000L</td>
                                <td>-Infinity</td>
                                <td>1.7976931348623E+308</td>
                            </tr>
                            <tr>
                                <td>0x441AC7A08EAD02F2L</td>
                                <td>1.234999999999999E20</td>
                                <td>1.235E+20</td>
                            </tr>
                            <tr>
                                <td>0x40FE26BFFFFFFFF9L</td>
                                <td>123499.9999999999</td>
                                <td>123500</td>
                            </tr>
                            <tr>
                                <td>0x3E4A857BFB2F2809L</td>
                                <td>1.234999999999999E-8</td>
                                <td>0.00000001235</td>
                            </tr>
                            <tr>
                                <td>0x3BCD291DEF868C89L</td>
                                <td>1.234999999999999E-20</td>
                                <td>1.235E-20</td>
                            </tr>
                            <tr>
                                <td>0x444B1AE4D6E2EF4FL</td>
                                <td>9.999999999999999E20</td>
                                <td>1E+21</td>
                            </tr>
                            <tr>
                                <td>0x412E847FFFFFFFFFL</td>
                                <td>999999.9999999999</td>
                                <td>1000000</td>
                            </tr>
                            <tr>
                                <td>0x3E45798EE2308C39L</td>
                                <td>9.999999999999999E-9</td>
                                <td>0.00000001</td>
                            </tr>
                            <tr>
                                <td>0x3C32725DD1D243ABL</td>
                                <td>9.999999999999999E-19</td>
                                <td>0.000000000000000001</td>
                            </tr>
                            <tr>
                                <td>0x3BFD83C94FB6D2ABL</td>
                                <td>9.999999999999999E-20</td>
                                <td>1E-19</td>
                            </tr>
                            <tr>
                                <td>0xC44B1AE4D6E2EF4FL</td>
                                <td>-9.999999999999999E20</td>
                                <td>-1E+21</td>
                            </tr>
                            <tr>
                                <td>0xC12E847FFFFFFFFFL</td>
                                <td>-999999.9999999999</td>
                                <td>-1000000</td>
                            </tr>
                            <tr>
                                <td>0xBE45798EE2308C39L</td>
                                <td>-9.999999999999999E-9</td>
                                <td>-0.00000001</td>
                            </tr>
                            <tr>
                                <td>0xBC32725DD1D243ABL</td>
                                <td>-9.999999999999999E-19</td>
                                <td>-0.000000000000000001</td>
                            </tr>
                            <tr>
                                <td>0xBBFD83C94FB6D2ABL</td>
                                <td>-9.999999999999999E-20</td>
                                <td>-1E-19</td>
                            </tr>
                            <tr>
                                <td>0xFFFF0420003C0000L</td>
                                <td>NaN</td>
                                <td>3.484840871308E+308</td>
                            </tr>
                            <tr>
                                <td>0x7FF8000000000000L</td>
                                <td>NaN</td>
                                <td>2.6965397022935E+308</td>
                            </tr>
                            <tr>
                                <td>0x7FFF0420003C0000L</td>
                                <td>NaN</td>
                                <td>3.484840871308E+308</td>
                            </tr>
                            <tr>
                                <td>0xFFF8000000000000L</td>
                                <td>NaN</td>
                                <td>2.6965397022935E+308</td>
                            </tr>
                            <tr>
                                <td>0xFFFF0AAAAAAAAAAAL</td>
                                <td>NaN</td>
                                <td>3.4877119413344E+308</td>
                            </tr>
                            <tr>
                                <td>0x7FF80AAAAAAAAAAAL</td>
                                <td>NaN</td>
                                <td>2.7012211948322E+308</td>
                            </tr>
                            <tr>
                                <td>0xFFFFFFFFFFFFFFFFL</td>
                                <td>NaN</td>
                                <td>3.5953862697246E+308</td>
                            </tr>
                            <tr>
                                <td>0x7FFFFFFFFFFFFFFFL</td>
                                <td>NaN</td>
                                <td>3.5953862697246E+308</td>
                            </tr>
                            <tr>
                                <td>0xFFF7FFFFFFFFFFFFL</td>
                                <td>NaN</td>
                                <td>2.6965397022935E+308</td>
                            </tr>
                        </table>

                        <b>Note</b>:
                        Excel has inconsistent rules for the following numeric operations:
                        <ul>
                            <li>Conversion to string (as handled here)</li>
                            <li>Rendering numerical quantities in the cell grid.</li>
                            <li>Conversion from text</li>
                            <li>General arithmetic</li>
                        </ul>
                        Excel's text to number conversion is not a true <i>inverse</i> of this operation. The
                        allowable ranges are different. Some numbers that don't correctly convert to text actually
                        <b>do</b> get handled properly when used in arithmetic evaluations.</div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Josh Micich</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/util/NumberToTextConverter.html#toText-double-">toText</a></span>(double&nbsp;value)</code>
                                    <div class="block">Converts the supplied <tt>value</tt> to the text representation
                                        that Excel would give if
                                        the value were to appear in an unformatted cell, or as a literal number in a
                                        formula.<br>
                                        Note - the results from this method differ slightly from those of <tt>Double.toString()</tt>
                                        In some special cases Excel behaves quite differently.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="toText-double-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>toText</h4>
                                <pre>public static&nbsp;java.lang.String&nbsp;toText(double&nbsp;value)</pre>
                                <div class="block">Converts the supplied <tt>value</tt> to the text representation that
                                    Excel would give if
                                    the value were to appear in an unformatted cell, or as a literal number in a
                                    formula.<br>
                                    Note - the results from this method differ slightly from those of <tt>Double.toString()</tt>
                                    In some special cases Excel behaves quite differently. This function attempts to
                                    reproduce
                                    those results.
                                </div>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/NumberToTextConverter.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/util/NumberComparer.html" title="class in org.apache.poi.ss.util"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/ss/util/PaneInformation.html"
               title="class in org.apache.poi.ss.util"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/util/NumberToTextConverter.html"
               target="_top">Frames</a></li>
        <li><a href="NumberToTextConverter.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
